<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.metabolic.compress;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.util.Arrays;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.util.Set;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.util.logging.Level;<a name="line.38"></a>
<FONT color="green">039</FONT>    import java.util.logging.Logger;<a name="line.39"></a>
<FONT color="green">040</FONT>    <a name="line.40"></a>
<FONT color="green">041</FONT>    import ch.javasoft.metabolic.MetabolicNetwork;<a name="line.41"></a>
<FONT color="green">042</FONT>    import ch.javasoft.metabolic.Metabolite;<a name="line.42"></a>
<FONT color="green">043</FONT>    import ch.javasoft.metabolic.Reaction;<a name="line.43"></a>
<FONT color="green">044</FONT>    import ch.javasoft.metabolic.impl.AbstractMetabolicNetwork;<a name="line.44"></a>
<FONT color="green">045</FONT>    import ch.javasoft.metabolic.impl.FractionNumberStoichMetabolicNetwork;<a name="line.45"></a>
<FONT color="green">046</FONT>    import ch.javasoft.metabolic.util.MetabolicNetworkUtil;<a name="line.46"></a>
<FONT color="green">047</FONT>    import ch.javasoft.smx.iface.ReadableBigIntegerRationalMatrix;<a name="line.47"></a>
<FONT color="green">048</FONT>    import ch.javasoft.smx.iface.ReadableMatrix;<a name="line.48"></a>
<FONT color="green">049</FONT>    import ch.javasoft.smx.iface.WritableMatrix;<a name="line.49"></a>
<FONT color="green">050</FONT>    import ch.javasoft.util.genarr.ArrayIterable;<a name="line.50"></a>
<FONT color="green">051</FONT>    import ch.javasoft.util.logging.LogPrintWriter;<a name="line.51"></a>
<FONT color="green">052</FONT>    import ch.javasoft.util.logging.Loggers;<a name="line.52"></a>
<FONT color="green">053</FONT>    import ch.javasoft.util.numeric.Zero;<a name="line.53"></a>
<FONT color="green">054</FONT>    <a name="line.54"></a>
<FONT color="green">055</FONT>    public class CompressionUtil {<a name="line.55"></a>
<FONT color="green">056</FONT>            <a name="line.56"></a>
<FONT color="green">057</FONT>            private static final Logger LOG          = LogPkg.LOGGER;<a name="line.57"></a>
<FONT color="green">058</FONT>            private static final Logger LOG_DATA = Loggers.getLogger(LOG.getName() + ".data", -2);<a name="line.58"></a>
<FONT color="green">059</FONT>    <a name="line.59"></a>
<FONT color="green">060</FONT>            /**<a name="line.60"></a>
<FONT color="green">061</FONT>             * Compresses the given network, using zero tolerance and <a name="line.61"></a>
<FONT color="green">062</FONT>             * {@link CompressionMethod#STANDARD standard compression}. No reactions are<a name="line.62"></a>
<FONT color="green">063</FONT>             * suppressed, duplicate gene compression is not applied. <a name="line.63"></a>
<FONT color="green">064</FONT>             * <a name="line.64"></a>
<FONT color="green">065</FONT>             * @param net   the network to compress<a name="line.65"></a>
<FONT color="green">066</FONT>             * @return              the compressed network<a name="line.66"></a>
<FONT color="green">067</FONT>             */<a name="line.67"></a>
<FONT color="green">068</FONT>            public static CompressedMetabolicNetwork compress(MetabolicNetwork net) {<a name="line.68"></a>
<FONT color="green">069</FONT>                    return compress(net, null);<a name="line.69"></a>
<FONT color="green">070</FONT>            }<a name="line.70"></a>
<FONT color="green">071</FONT>            /**<a name="line.71"></a>
<FONT color="green">072</FONT>             * Compresses the given network, using zero tolerance and <a name="line.72"></a>
<FONT color="green">073</FONT>             * {@link CompressionMethod#STANDARD standard compression}. The specified <a name="line.73"></a>
<FONT color="green">074</FONT>             * reactions are suppressed, duplicate gene compression is not applied. <a name="line.74"></a>
<FONT color="green">075</FONT>             * <a name="line.75"></a>
<FONT color="green">076</FONT>             * @param net                                   the network to compress<a name="line.76"></a>
<FONT color="green">077</FONT>             * @param suppressedReactions   the reactions to suppress, i.e. to exclude<a name="line.77"></a>
<FONT color="green">078</FONT>             *                                                              in the compressed network<a name="line.78"></a>
<FONT color="green">079</FONT>             * @return              the compressed network<a name="line.79"></a>
<FONT color="green">080</FONT>             */<a name="line.80"></a>
<FONT color="green">081</FONT>            public static CompressedMetabolicNetwork compress(MetabolicNetwork net, Set&lt;String&gt; suppressedReactions) {<a name="line.81"></a>
<FONT color="green">082</FONT>                    return compress(net, CompressionMethod.STANDARD, suppressedReactions);<a name="line.82"></a>
<FONT color="green">083</FONT>            }<a name="line.83"></a>
<FONT color="green">084</FONT>            /**<a name="line.84"></a>
<FONT color="green">085</FONT>             * Compresses the given network, using the default zero tolerance and <a name="line.85"></a>
<FONT color="green">086</FONT>             * compression methods. Reactions in the suppressed reactions set are <a name="line.86"></a>
<FONT color="green">087</FONT>             * removed in the compressed network, duplicate gene compression is not <a name="line.87"></a>
<FONT color="green">088</FONT>             * applied. <a name="line.88"></a>
<FONT color="green">089</FONT>             * <a name="line.89"></a>
<FONT color="green">090</FONT>             * @param net                                   the network to compress<a name="line.90"></a>
<FONT color="green">091</FONT>             * @param methods                               the compression methods to apply<a name="line.91"></a>
<FONT color="green">092</FONT>             * @param suppressedReactions   the reactions to suppress, i.e. to exclude<a name="line.92"></a>
<FONT color="green">093</FONT>             *                                                              in the compressed network<a name="line.93"></a>
<FONT color="green">094</FONT>             * @return the compressed network<a name="line.94"></a>
<FONT color="green">095</FONT>             */<a name="line.95"></a>
<FONT color="green">096</FONT>            public static CompressedMetabolicNetwork compress(MetabolicNetwork net, CompressionMethod[] methods, Set&lt;String&gt; suppressedReactions) {<a name="line.96"></a>
<FONT color="green">097</FONT>                    return compress(net, methods, suppressedReactions, new Zero(0d));<a name="line.97"></a>
<FONT color="green">098</FONT>            }<a name="line.98"></a>
<FONT color="green">099</FONT>            /**<a name="line.99"></a>
<FONT color="green">100</FONT>             * Compresses the given network, using the given zero tolerance and <a name="line.100"></a>
<FONT color="green">101</FONT>             * compression methods. Reactions in the suppressed reactions set are <a name="line.101"></a>
<FONT color="green">102</FONT>             * removed in the compressed network, duplicate gene compression is not <a name="line.102"></a>
<FONT color="green">103</FONT>             * applied. <a name="line.103"></a>
<FONT color="green">104</FONT>             * <a name="line.104"></a>
<FONT color="green">105</FONT>             * @param net                                   the network to compress<a name="line.105"></a>
<FONT color="green">106</FONT>             * @param methods                               the compression methods to apply<a name="line.106"></a>
<FONT color="green">107</FONT>             * @param zero                                  the zero tolerance to use<a name="line.107"></a>
<FONT color="green">108</FONT>             * @param suppressedReactions   the reactions to suppress, i.e. to exclude<a name="line.108"></a>
<FONT color="green">109</FONT>             *                                                              in the compressed network<a name="line.109"></a>
<FONT color="green">110</FONT>             * @return the compressed network<a name="line.110"></a>
<FONT color="green">111</FONT>             */<a name="line.111"></a>
<FONT color="green">112</FONT>            public static CompressedMetabolicNetwork compress(MetabolicNetwork net, CompressionMethod[] methods, Set&lt;String&gt; suppressedReactions, Zero zero) {<a name="line.112"></a>
<FONT color="green">113</FONT>                    final CompressedMetabolicNetwork cmpNet;<a name="line.113"></a>
<FONT color="green">114</FONT>    <a name="line.114"></a>
<FONT color="green">115</FONT>                    final boolean[] reversible                                              = net.getReactionReversibilities();<a name="line.115"></a>
<FONT color="green">116</FONT>                    final ReadableBigIntegerRationalMatrix stoich   = FractionNumberStoichMetabolicNetwork.getStoich(net);<a name="line.116"></a>
<FONT color="green">117</FONT>                    final String[] metaNames                                                = net.getMetaboliteNames();<a name="line.117"></a>
<FONT color="green">118</FONT>                    final String[] reacNames                                                = net.getReactionNames();<a name="line.118"></a>
<FONT color="green">119</FONT>                    <a name="line.119"></a>
<FONT color="green">120</FONT>                    final StoichMatrixCompressor.CompressionRecord rec = new StoichMatrixCompressor(methods).compress(stoich, reversible, metaNames, reacNames, suppressedReactions);<a name="line.120"></a>
<FONT color="green">121</FONT>                    sortMatrix(rec.cmp, rec.post, rec.reversible);<a name="line.121"></a>
<FONT color="green">122</FONT>                    logCompressionRecord(stoich, rec, Level.FINER);<a name="line.122"></a>
<FONT color="green">123</FONT>                    cmpNet = new StoichMatrixCompressedMetabolicNetwork(net, rec.pre, rec.post, rec.cmp);<a name="line.123"></a>
<FONT color="green">124</FONT>                    //consistency check for reversibilities:<a name="line.124"></a>
<FONT color="green">125</FONT>                    if (!Arrays.equals(rec.reversible, cmpNet.getReactionReversibilities())) {<a name="line.125"></a>
<FONT color="green">126</FONT>                            LOG.warning("reversibility missmatch:");<a name="line.126"></a>
<FONT color="green">127</FONT>                            LOG.warning("  reversibility(cmp.rec) = " + Arrays.toString(rec.reversible));<a name="line.127"></a>
<FONT color="green">128</FONT>                            LOG.warning("  reversibility(cmp.net) = " + Arrays.toString(cmpNet.getReactionReversibilities()));<a name="line.128"></a>
<FONT color="green">129</FONT>                            throw new RuntimeException("reversibility missmatch, see log for details");<a name="line.129"></a>
<FONT color="green">130</FONT>                    }<a name="line.130"></a>
<FONT color="green">131</FONT>                    if (LOG.isLoggable(Level.FINE)) {<a name="line.131"></a>
<FONT color="green">132</FONT>                            CompressionMethod.log(Level.FINE, methods);<a name="line.132"></a>
<FONT color="green">133</FONT>                            LOG.fine(MetabolicNetworkUtil.getNetworkSizeString("Uncompressed network size: ", net));<a name="line.133"></a>
<FONT color="green">134</FONT>                            LOG.fine(MetabolicNetworkUtil.getNetworkSizeString("Compressed network size: ", cmpNet));<a name="line.134"></a>
<FONT color="green">135</FONT>                    }<a name="line.135"></a>
<FONT color="green">136</FONT>                    return cmpNet;<a name="line.136"></a>
<FONT color="green">137</FONT>            }<a name="line.137"></a>
<FONT color="green">138</FONT>            <a name="line.138"></a>
<FONT color="green">139</FONT>            /**<a name="line.139"></a>
<FONT color="green">140</FONT>             * Performs the duplicate gene compression. This compression method is <a name="line.140"></a>
<FONT color="green">141</FONT>             * usually made in advance, and efms for the duplicate-free network is <a name="line.141"></a>
<FONT color="green">142</FONT>             * computed. It might be a good idea to call <a name="line.142"></a>
<FONT color="green">143</FONT>             * {@link #convertToNoncompressed(MetabolicNetwork)} with the <a name="line.143"></a>
<FONT color="green">144</FONT>             * returned network since uncompressing efms for duplicate gene compressed<a name="line.144"></a>
<FONT color="green">145</FONT>             * networks does not work properly.<a name="line.145"></a>
<FONT color="green">146</FONT>             */<a name="line.146"></a>
<FONT color="green">147</FONT>            public static MetabolicNetwork compressDuplicateGeneReactions(MetabolicNetwork net, Zero zero, CompressionMethod... methods) {<a name="line.147"></a>
<FONT color="green">148</FONT>                    //if (true) return convertToNoncompressed(compress(net, CompressionMethod.methods(CompressionMethod.DuplicateGene), zero, true));<a name="line.148"></a>
<FONT color="green">149</FONT>                    final boolean[] reversible                                              = net.getReactionReversibilities();<a name="line.149"></a>
<FONT color="green">150</FONT>                    final ReadableBigIntegerRationalMatrix stoich   = FractionNumberStoichMetabolicNetwork.getStoich(net);<a name="line.150"></a>
<FONT color="green">151</FONT>                    final String[] metaNames                                                = net.getMetaboliteNames();<a name="line.151"></a>
<FONT color="green">152</FONT>                    final String[] reacNames                                                = net.getReactionNames();<a name="line.152"></a>
<FONT color="green">153</FONT>                    final boolean doExtendedDuplicates                              = CompressionMethod.DuplicateGeneExtended.containedIn(methods);<a name="line.153"></a>
<FONT color="green">154</FONT>                    <a name="line.154"></a>
<FONT color="green">155</FONT>                    final DuplicateGeneCompressor.CompressionRecord rec = DuplicateGeneCompressor.compress(stoich, reversible, metaNames, reacNames, doExtendedDuplicates);<a name="line.155"></a>
<FONT color="green">156</FONT>                    sortMatrix(rec.dupfree, rec.dupelim, rec.reversible);<a name="line.156"></a>
<FONT color="green">157</FONT>                    logCompressionRecord(stoich, rec, Level.FINER);<a name="line.157"></a>
<FONT color="green">158</FONT>                    final MetabolicNetwork dupfreeNet;<a name="line.158"></a>
<FONT color="green">159</FONT>                    dupfreeNet = new FractionNumberStoichMetabolicNetwork(rec.metaNames, rec.reacNames, rec.dupfree, rec.reversible);<a name="line.159"></a>
<FONT color="green">160</FONT>                    if (LOG.isLoggable(Level.FINE)) {<a name="line.160"></a>
<FONT color="green">161</FONT>                            CompressionMethod.log(Level.FINE, CompressionMethod.DuplicateGene);<a name="line.161"></a>
<FONT color="green">162</FONT>                            LOG.fine(MetabolicNetworkUtil.getNetworkSizeString("Uncompressed network size: ", net));<a name="line.162"></a>
<FONT color="green">163</FONT>                            LOG.fine(MetabolicNetworkUtil.getNetworkSizeString("Duplicate free network size: ", dupfreeNet));<a name="line.163"></a>
<FONT color="green">164</FONT>                    }<a name="line.164"></a>
<FONT color="green">165</FONT>                    return dupfreeNet;<a name="line.165"></a>
<FONT color="green">166</FONT>            }<a name="line.166"></a>
<FONT color="green">167</FONT>            <a name="line.167"></a>
<FONT color="green">168</FONT>            /**<a name="line.168"></a>
<FONT color="green">169</FONT>             * Nests the given compressed network such that the returned network is no<a name="line.169"></a>
<FONT color="green">170</FONT>             * more recognizable as a compressed network. This can be useful if <a name="line.170"></a>
<FONT color="green">171</FONT>             * uncompression is performed automatically by recognizing compressed <a name="line.171"></a>
<FONT color="green">172</FONT>             * networks, but uncompression is not desired.<a name="line.172"></a>
<FONT color="green">173</FONT>             * <a name="line.173"></a>
<FONT color="green">174</FONT>             * @param cNet  The compressed network to convert to a noncompressed one<a name="line.174"></a>
<FONT color="green">175</FONT>             * @return              A metabolic network nesting the given compressed network<a name="line.175"></a>
<FONT color="green">176</FONT>             */<a name="line.176"></a>
<FONT color="green">177</FONT>            public static MetabolicNetwork convertToNoncompressed(final MetabolicNetwork cNet) {<a name="line.177"></a>
<FONT color="green">178</FONT>                    return new AbstractMetabolicNetwork() {<a name="line.178"></a>
<FONT color="green">179</FONT>                            public ArrayIterable&lt;? extends Metabolite&gt; getMetabolites() {<a name="line.179"></a>
<FONT color="green">180</FONT>                                    return cNet.getMetabolites();<a name="line.180"></a>
<FONT color="green">181</FONT>                            }<a name="line.181"></a>
<FONT color="green">182</FONT>                            public ArrayIterable&lt;? extends Reaction&gt; getReactions() {<a name="line.182"></a>
<FONT color="green">183</FONT>                                    return cNet.getReactions();<a name="line.183"></a>
<FONT color="green">184</FONT>                            }<a name="line.184"></a>
<FONT color="green">185</FONT>                            public ReadableMatrix&lt;?&gt; getStoichiometricMatrix() {<a name="line.185"></a>
<FONT color="green">186</FONT>                                    return cNet.getStoichiometricMatrix();<a name="line.186"></a>
<FONT color="green">187</FONT>                            }<a name="line.187"></a>
<FONT color="green">188</FONT>                    };<a name="line.188"></a>
<FONT color="green">189</FONT>            }<a name="line.189"></a>
<FONT color="green">190</FONT>            <a name="line.190"></a>
<FONT color="green">191</FONT>            /**<a name="line.191"></a>
<FONT color="green">192</FONT>             * Logs the given compression record to the LOG_DATA logger, using the <a name="line.192"></a>
<FONT color="green">193</FONT>             * specified log level.<a name="line.193"></a>
<FONT color="green">194</FONT>             * <a name="line.194"></a>
<FONT color="green">195</FONT>             * @param rec           the compression record to trace<a name="line.195"></a>
<FONT color="green">196</FONT>             * @param level         the log level used for tracing<a name="line.196"></a>
<FONT color="green">197</FONT>             */<a name="line.197"></a>
<FONT color="green">198</FONT>            public static void logCompressionRecord(final StoichMatrixCompressor.CompressionRecord rec, Level level) {<a name="line.198"></a>
<FONT color="green">199</FONT>                    logCompressionRecord(null, rec, level);<a name="line.199"></a>
<FONT color="green">200</FONT>            }<a name="line.200"></a>
<FONT color="green">201</FONT>            /**<a name="line.201"></a>
<FONT color="green">202</FONT>             * Logs the given compression record and stoichiometric matrix to the <a name="line.202"></a>
<FONT color="green">203</FONT>             * LOG_DATA logger, using the specified log level.<a name="line.203"></a>
<FONT color="green">204</FONT>             * <a name="line.204"></a>
<FONT color="green">205</FONT>             * @param stoich        the stoichiometric matrix to trace<a name="line.205"></a>
<FONT color="green">206</FONT>             * @param rec           the compression record to trace<a name="line.206"></a>
<FONT color="green">207</FONT>             * @param level         the log level used for tracing<a name="line.207"></a>
<FONT color="green">208</FONT>             */<a name="line.208"></a>
<FONT color="green">209</FONT>            public static void logCompressionRecord(final ReadableMatrix&lt;?&gt; stoich, final StoichMatrixCompressor.CompressionRecord rec, Level level) {<a name="line.209"></a>
<FONT color="green">210</FONT>                    if (Loggers.isLoggable(LOG_DATA, level)) {<a name="line.210"></a>
<FONT color="green">211</FONT>                            LogPrintWriter dataLogger = new LogPrintWriter(LOG_DATA, level);<a name="line.211"></a>
<FONT color="green">212</FONT>                            LOG_DATA.log(level, "compression matrices:");<a name="line.212"></a>
<FONT color="green">213</FONT>                            LOG_DATA.log(level, "  pre * stoich * post  = cmp");<a name="line.213"></a>
<FONT color="green">214</FONT>                            LOG_DATA.log(level, "efm uncompression:");<a name="line.214"></a>
<FONT color="green">215</FONT>                            LOG_DATA.log(level, "  stoich * post * efmc = 0");<a name="line.215"></a>
<FONT color="green">216</FONT>                            LOG_DATA.log(level, "  stoich * efm         = 0");<a name="line.216"></a>
<FONT color="green">217</FONT>                            LOG_DATA.log(level, "  --&gt;      efm         = post * efmc");<a name="line.217"></a>
<FONT color="green">218</FONT>                            if (stoich != null) {<a name="line.218"></a>
<FONT color="green">219</FONT>                                    LOG_DATA.log(level, "stoich: ");<a name="line.219"></a>
<FONT color="green">220</FONT>                                    stoich.writeToMultiline(dataLogger);<a name="line.220"></a>
<FONT color="green">221</FONT>                            }<a name="line.221"></a>
<FONT color="green">222</FONT>                            LOG_DATA.log(level, "pre: ");<a name="line.222"></a>
<FONT color="green">223</FONT>                            rec.pre.writeToMultiline(dataLogger);<a name="line.223"></a>
<FONT color="green">224</FONT>                            LOG_DATA.log(level, "post: ");<a name="line.224"></a>
<FONT color="green">225</FONT>                            rec.post.writeToMultiline(dataLogger);<a name="line.225"></a>
<FONT color="green">226</FONT>                            LOG_DATA.log(level, "cmp: ");<a name="line.226"></a>
<FONT color="green">227</FONT>                            rec.cmp.writeToMultiline(dataLogger);<a name="line.227"></a>
<FONT color="green">228</FONT>                            LOG_DATA.log(level, "cmp_reversibilities = " + Arrays.toString(rec.reversible));<a name="line.228"></a>
<FONT color="green">229</FONT>                    }               <a name="line.229"></a>
<FONT color="green">230</FONT>            }<a name="line.230"></a>
<FONT color="green">231</FONT>            /**<a name="line.231"></a>
<FONT color="green">232</FONT>             * Logs the given compression record to the LOG_DATA logger, using the <a name="line.232"></a>
<FONT color="green">233</FONT>             * specified log level.<a name="line.233"></a>
<FONT color="green">234</FONT>             * <a name="line.234"></a>
<FONT color="green">235</FONT>             * @param rec           the compression record to trace<a name="line.235"></a>
<FONT color="green">236</FONT>             * @param level         the log level used for tracing<a name="line.236"></a>
<FONT color="green">237</FONT>             */<a name="line.237"></a>
<FONT color="green">238</FONT>            public static void logCompressionRecord(final DuplicateGeneCompressor.CompressionRecord rec, Level level) {<a name="line.238"></a>
<FONT color="green">239</FONT>                    logCompressionRecord(null, rec, level);<a name="line.239"></a>
<FONT color="green">240</FONT>            }<a name="line.240"></a>
<FONT color="green">241</FONT>            /**<a name="line.241"></a>
<FONT color="green">242</FONT>             * Logs the given compression record and stoichiometric matrix to the <a name="line.242"></a>
<FONT color="green">243</FONT>             * LOG_DATA logger, using the specified log level.<a name="line.243"></a>
<FONT color="green">244</FONT>             * <a name="line.244"></a>
<FONT color="green">245</FONT>             * @param stoich        the stoichiometric matrix to trace<a name="line.245"></a>
<FONT color="green">246</FONT>             * @param rec           the compression record to trace<a name="line.246"></a>
<FONT color="green">247</FONT>             * @param level         the log level used for tracing<a name="line.247"></a>
<FONT color="green">248</FONT>             */<a name="line.248"></a>
<FONT color="green">249</FONT>            public static void logCompressionRecord(final ReadableMatrix&lt;?&gt; stoich, final DuplicateGeneCompressor.CompressionRecord rec, Level level) {<a name="line.249"></a>
<FONT color="green">250</FONT>                    if (Loggers.isLoggable(LOG_DATA, level)) {<a name="line.250"></a>
<FONT color="green">251</FONT>                            LogPrintWriter dataLogger = new LogPrintWriter(LOG_DATA, level);<a name="line.251"></a>
<FONT color="green">252</FONT>                            LOG_DATA.log(level, "compression matrices:");<a name="line.252"></a>
<FONT color="green">253</FONT>                            LOG_DATA.log(level, "  stoich * dupelim = dupfree");<a name="line.253"></a>
<FONT color="green">254</FONT>                            if (stoich != null) {<a name="line.254"></a>
<FONT color="green">255</FONT>                                    LOG_DATA.log(level, "stoich: ");<a name="line.255"></a>
<FONT color="green">256</FONT>                                    stoich.writeToMultiline(dataLogger);<a name="line.256"></a>
<FONT color="green">257</FONT>                            }<a name="line.257"></a>
<FONT color="green">258</FONT>                            LOG_DATA.log(level, "dupelim: ");<a name="line.258"></a>
<FONT color="green">259</FONT>                            rec.dupelim.writeToMultiline(dataLogger);<a name="line.259"></a>
<FONT color="green">260</FONT>                            LOG_DATA.log(level, "dupfree: ");<a name="line.260"></a>
<FONT color="green">261</FONT>                            rec.dupfree.writeToMultiline(dataLogger);<a name="line.261"></a>
<FONT color="green">262</FONT>                            LOG_DATA.log(level, "dupfree_reversibilities = " + Arrays.toString(rec.reversible));<a name="line.262"></a>
<FONT color="green">263</FONT>                            LOG_DATA.log(level, "dupgroups: " + Arrays.toString(rec.dupgroups));<a name="line.263"></a>
<FONT color="green">264</FONT>                    }               <a name="line.264"></a>
<FONT color="green">265</FONT>            }<a name="line.265"></a>
<FONT color="green">266</FONT>            <a name="line.266"></a>
<FONT color="green">267</FONT>            private static &lt;N extends Number, M extends ReadableMatrix&lt;N&gt; &amp; WritableMatrix&lt;N&gt;&gt; void sortMatrix(M stoich, M post, boolean[] reversibilities) {<a name="line.267"></a>
<FONT color="green">268</FONT>                    //sortMatrixNone(stoich, post, reversibilities);<a name="line.268"></a>
<FONT color="green">269</FONT>    <a name="line.269"></a>
<FONT color="green">270</FONT>                    //sometimes not too bad<a name="line.270"></a>
<FONT color="green">271</FONT>                    sortMatrixDiagStoich(stoich, post, reversibilities);<a name="line.271"></a>
<FONT color="green">272</FONT>                    //sortMatrixFewNonZeroColsStoich(stoich, post, reversibilities);<a name="line.272"></a>
<FONT color="green">273</FONT>    <a name="line.273"></a>
<FONT color="green">274</FONT>                    //not so good<a name="line.274"></a>
<FONT color="green">275</FONT>                    //sortMatrixDiagPost(stoich, post, reversibilities);<a name="line.275"></a>
<FONT color="green">276</FONT>                    //sortMatrixFewNonZeroColsPost(stoich, post, reversibilities);<a name="line.276"></a>
<FONT color="green">277</FONT>            }<a name="line.277"></a>
<FONT color="green">278</FONT>    <a name="line.278"></a>
<FONT color="green">279</FONT>            ////////////// helpers<a name="line.279"></a>
<FONT color="green">280</FONT>            @SuppressWarnings("unused")<a name="line.280"></a>
<FONT color="green">281</FONT>            private static &lt;N extends Number, M extends ReadableMatrix&lt;N&gt; &amp; WritableMatrix&lt;N&gt;&gt; void sortMatrixNone(M stoich, M post, boolean[] reversibilities) {<a name="line.281"></a>
<FONT color="green">282</FONT>                    //dont sort<a name="line.282"></a>
<FONT color="green">283</FONT>            }<a name="line.283"></a>
<FONT color="green">284</FONT>            /**<a name="line.284"></a>
<FONT color="green">285</FONT>             * Sorts the matrices by swapping columns. Columns with fewer non-zero <a name="line.285"></a>
<FONT color="green">286</FONT>             * entries are placed at lower indices. If 2 colums have the same number of <a name="line.286"></a>
<FONT color="green">287</FONT>             * non-zero entries, the column with the lower row index for the first <a name="line.287"></a>
<FONT color="green">288</FONT>             * non-zero entry is placed at a lower index.<a name="line.288"></a>
<FONT color="green">289</FONT>             */<a name="line.289"></a>
<FONT color="green">290</FONT>            @SuppressWarnings("unused")<a name="line.290"></a>
<FONT color="green">291</FONT>            private static &lt;N extends Number, M extends ReadableMatrix&lt;N&gt; &amp; WritableMatrix&lt;N&gt;&gt; void sortMatrixFewNonZeroColsPost(M stoich, M post, boolean[] reversibilities) {<a name="line.291"></a>
<FONT color="green">292</FONT>                    final int rows = stoich.getRowCount();<a name="line.292"></a>
<FONT color="green">293</FONT>                    final int cols = stoich.getColumnCount();<a name="line.293"></a>
<FONT color="green">294</FONT>                    for (int piv = 0; piv &lt; cols; piv++) {<a name="line.294"></a>
<FONT color="green">295</FONT>                            //find the column with an entry in the lowest row in post<a name="line.295"></a>
<FONT color="green">296</FONT>                            int pivcol = piv;<a name="line.296"></a>
<FONT color="green">297</FONT>                            int pivcnt = Integer.MAX_VALUE;<a name="line.297"></a>
<FONT color="green">298</FONT>                            int pivrow = Integer.MAX_VALUE;<a name="line.298"></a>
<FONT color="green">299</FONT>                            for (int col = piv; col &lt; cols; col++) {<a name="line.299"></a>
<FONT color="green">300</FONT>                                    int rowFirst = Integer.MAX_VALUE;<a name="line.300"></a>
<FONT color="green">301</FONT>                                    int cnt = 0;<a name="line.301"></a>
<FONT color="green">302</FONT>                                    for (int row = 0; row &lt; rows; row++) {<a name="line.302"></a>
<FONT color="green">303</FONT>                                            if (post.getSignumAt(row, col) != 0) {<a name="line.303"></a>
<FONT color="green">304</FONT>                                                    rowFirst = Math.min(row, rowFirst);<a name="line.304"></a>
<FONT color="green">305</FONT>                                                    cnt++;<a name="line.305"></a>
<FONT color="green">306</FONT>                                            }<a name="line.306"></a>
<FONT color="green">307</FONT>                                    }<a name="line.307"></a>
<FONT color="green">308</FONT>                                    if (cnt &lt; pivcnt || (cnt == pivcnt &amp;&amp; rowFirst &lt; pivrow)) {<a name="line.308"></a>
<FONT color="green">309</FONT>                                            pivcol = col;<a name="line.309"></a>
<FONT color="green">310</FONT>                                            pivcnt = cnt;<a name="line.310"></a>
<FONT color="green">311</FONT>                                            pivrow = rowFirst;<a name="line.311"></a>
<FONT color="green">312</FONT>                                    }<a name="line.312"></a>
<FONT color="green">313</FONT>                            }<a name="line.313"></a>
<FONT color="green">314</FONT>                            <a name="line.314"></a>
<FONT color="green">315</FONT>                            if (pivcol != piv) {<a name="line.315"></a>
<FONT color="green">316</FONT>                                    stoich.swapColumns(pivcol, piv);<a name="line.316"></a>
<FONT color="green">317</FONT>                                    post.swapColumns(pivcol, piv);<a name="line.317"></a>
<FONT color="green">318</FONT>                                    ch.javasoft.util.Arrays.swap(reversibilities, pivcol, piv);<a name="line.318"></a>
<FONT color="green">319</FONT>                            }<a name="line.319"></a>
<FONT color="green">320</FONT>                    }               <a name="line.320"></a>
<FONT color="green">321</FONT>            }<a name="line.321"></a>
<FONT color="green">322</FONT>            /**<a name="line.322"></a>
<FONT color="green">323</FONT>             * Sorts the matrices by swapping columns. Columns with fewer non-zero <a name="line.323"></a>
<FONT color="green">324</FONT>             * entries are placed at lower indices. If 2 colums have the same number of <a name="line.324"></a>
<FONT color="green">325</FONT>             * non-zero entries, the column with the lower row index for the first <a name="line.325"></a>
<FONT color="green">326</FONT>             * non-zero entry is placed at a lower index.<a name="line.326"></a>
<FONT color="green">327</FONT>             */<a name="line.327"></a>
<FONT color="green">328</FONT>            @SuppressWarnings("unused")<a name="line.328"></a>
<FONT color="green">329</FONT>            private static &lt;N extends Number, M extends ReadableMatrix&lt;N&gt; &amp; WritableMatrix&lt;N&gt;&gt; void sortMatrixFewNonZeroColsStoich(M stoich, M post, boolean[] reversibilities) {<a name="line.329"></a>
<FONT color="green">330</FONT>                    final int rows = stoich.getRowCount();<a name="line.330"></a>
<FONT color="green">331</FONT>                    final int cols = stoich.getColumnCount();<a name="line.331"></a>
<FONT color="green">332</FONT>                    for (int piv = 0; piv &lt; cols; piv++) {<a name="line.332"></a>
<FONT color="green">333</FONT>                            //find the column with an entry in the lowest row in stoich<a name="line.333"></a>
<FONT color="green">334</FONT>                            int pivcol = piv;<a name="line.334"></a>
<FONT color="green">335</FONT>                            int pivcnt = Integer.MAX_VALUE;<a name="line.335"></a>
<FONT color="green">336</FONT>                            int pivrow = Integer.MAX_VALUE;<a name="line.336"></a>
<FONT color="green">337</FONT>                            for (int col = piv; col &lt; cols; col++) {<a name="line.337"></a>
<FONT color="green">338</FONT>                                    int rowFirst = Integer.MAX_VALUE;<a name="line.338"></a>
<FONT color="green">339</FONT>                                    int cnt = 0;<a name="line.339"></a>
<FONT color="green">340</FONT>                                    for (int row = 0; row &lt; rows; row++) {<a name="line.340"></a>
<FONT color="green">341</FONT>                                            if (stoich.getSignumAt(row, col) != 0) {<a name="line.341"></a>
<FONT color="green">342</FONT>                                                    rowFirst = Math.min(row, rowFirst);<a name="line.342"></a>
<FONT color="green">343</FONT>                                                    cnt++;<a name="line.343"></a>
<FONT color="green">344</FONT>                                            }<a name="line.344"></a>
<FONT color="green">345</FONT>                                    }<a name="line.345"></a>
<FONT color="green">346</FONT>                                    if (cnt &lt; pivcnt || (cnt == pivcnt &amp;&amp; rowFirst &lt; pivrow)) {<a name="line.346"></a>
<FONT color="green">347</FONT>                                            pivcol = col;<a name="line.347"></a>
<FONT color="green">348</FONT>                                            pivcnt = cnt;<a name="line.348"></a>
<FONT color="green">349</FONT>                                            pivrow = rowFirst;<a name="line.349"></a>
<FONT color="green">350</FONT>                                    }<a name="line.350"></a>
<FONT color="green">351</FONT>                            }<a name="line.351"></a>
<FONT color="green">352</FONT>                            <a name="line.352"></a>
<FONT color="green">353</FONT>                            if (pivcol != piv) {<a name="line.353"></a>
<FONT color="green">354</FONT>                                    stoich.swapColumns(pivcol, piv);<a name="line.354"></a>
<FONT color="green">355</FONT>                                    post.swapColumns(pivcol, piv);<a name="line.355"></a>
<FONT color="green">356</FONT>                                    ch.javasoft.util.Arrays.swap(reversibilities, pivcol, piv);<a name="line.356"></a>
<FONT color="green">357</FONT>                            }<a name="line.357"></a>
<FONT color="green">358</FONT>                    }               <a name="line.358"></a>
<FONT color="green">359</FONT>            }<a name="line.359"></a>
<FONT color="green">360</FONT>            /**<a name="line.360"></a>
<FONT color="green">361</FONT>             * Sorts the matrices by swapping columns. The matrix post was initially an<a name="line.361"></a>
<FONT color="green">362</FONT>             * identity matrix. Thus, entries should lie on the diagonal. Here, we try<a name="line.362"></a>
<FONT color="green">363</FONT>             * to resort the matrix in such a way that earlier columns have an earlier<a name="line.363"></a>
<FONT color="green">364</FONT>             * occurrance of non-zero elements in post.<a name="line.364"></a>
<FONT color="green">365</FONT>             */<a name="line.365"></a>
<FONT color="green">366</FONT>            @SuppressWarnings("unused")<a name="line.366"></a>
<FONT color="green">367</FONT>            private static &lt;N extends Number, M extends ReadableMatrix&lt;N&gt; &amp; WritableMatrix&lt;N&gt;&gt; void sortMatrixDiagPost(M stoich, M post, boolean[] reversibilities) {<a name="line.367"></a>
<FONT color="green">368</FONT>                    final int rows = stoich.getRowCount();<a name="line.368"></a>
<FONT color="green">369</FONT>                    final int cols = stoich.getColumnCount();<a name="line.369"></a>
<FONT color="green">370</FONT>                    for (int piv = 0; piv &lt; cols; piv++) {<a name="line.370"></a>
<FONT color="green">371</FONT>                            //find the column with an entry in the lowest row in post<a name="line.371"></a>
<FONT color="green">372</FONT>                            int pivcol = piv;<a name="line.372"></a>
<FONT color="green">373</FONT>                            int pivrow = Integer.MAX_VALUE;<a name="line.373"></a>
<FONT color="green">374</FONT>                            for (int col = piv; col &lt; cols; col++) {<a name="line.374"></a>
<FONT color="green">375</FONT>                                    for (int row = 0; row &lt; rows; row++) {<a name="line.375"></a>
<FONT color="green">376</FONT>                                            if (post.getSignumAt(row, col) != 0) {<a name="line.376"></a>
<FONT color="green">377</FONT>                                                    if (row &lt; pivrow) {<a name="line.377"></a>
<FONT color="green">378</FONT>                                                            pivrow = row;<a name="line.378"></a>
<FONT color="green">379</FONT>                                                            pivcol = col;<a name="line.379"></a>
<FONT color="green">380</FONT>                                                    }<a name="line.380"></a>
<FONT color="green">381</FONT>                                                    break;<a name="line.381"></a>
<FONT color="green">382</FONT>                                            }<a name="line.382"></a>
<FONT color="green">383</FONT>                                    }<a name="line.383"></a>
<FONT color="green">384</FONT>                                    if (pivrow == 0) break;<a name="line.384"></a>
<FONT color="green">385</FONT>                            }<a name="line.385"></a>
<FONT color="green">386</FONT>                            <a name="line.386"></a>
<FONT color="green">387</FONT>                            if (pivcol != piv) {<a name="line.387"></a>
<FONT color="green">388</FONT>                                    stoich.swapColumns(pivcol, piv);<a name="line.388"></a>
<FONT color="green">389</FONT>                                    post.swapColumns(pivcol, piv);<a name="line.389"></a>
<FONT color="green">390</FONT>                                    ch.javasoft.util.Arrays.swap(reversibilities, pivcol, piv);<a name="line.390"></a>
<FONT color="green">391</FONT>                            }<a name="line.391"></a>
<FONT color="green">392</FONT>                    }<a name="line.392"></a>
<FONT color="green">393</FONT>            }<a name="line.393"></a>
<FONT color="green">394</FONT>            /**<a name="line.394"></a>
<FONT color="green">395</FONT>             * Sorts the matrices by swapping columns. The heuristics here are that the<a name="line.395"></a>
<FONT color="green">396</FONT>             * stoichiometrix matrix should be approximately diagonal, i.e. entries <a name="line.396"></a>
<FONT color="green">397</FONT>             * should lie on the diagonal. We try to sort the matrix in such a way that <a name="line.397"></a>
<FONT color="green">398</FONT>             * earlier columns have an earlier occurrance of non-zero elements in stoich.<a name="line.398"></a>
<FONT color="green">399</FONT>             */<a name="line.399"></a>
<FONT color="green">400</FONT>            private static &lt;N extends Number, M extends ReadableMatrix&lt;N&gt; &amp; WritableMatrix&lt;N&gt;&gt; void sortMatrixDiagStoich(M stoich, M post, boolean[] reversibilities) {<a name="line.400"></a>
<FONT color="green">401</FONT>                    final int rows = stoich.getRowCount();<a name="line.401"></a>
<FONT color="green">402</FONT>                    final int cols = stoich.getColumnCount();<a name="line.402"></a>
<FONT color="green">403</FONT>                    for (int piv = 0; piv &lt; cols; piv++) {<a name="line.403"></a>
<FONT color="green">404</FONT>                            //find the column with an entry in the lowest row in stoich<a name="line.404"></a>
<FONT color="green">405</FONT>                            int pivcol = piv;<a name="line.405"></a>
<FONT color="green">406</FONT>                            int pivrow = Integer.MAX_VALUE;<a name="line.406"></a>
<FONT color="green">407</FONT>                            for (int col = piv; col &lt; cols; col++) {<a name="line.407"></a>
<FONT color="green">408</FONT>                                    for (int row = 0; row &lt; rows; row++) {<a name="line.408"></a>
<FONT color="green">409</FONT>                                            if (stoich.getSignumAt(row, col) != 0) {<a name="line.409"></a>
<FONT color="green">410</FONT>                                                    if (row &lt; pivrow) {<a name="line.410"></a>
<FONT color="green">411</FONT>                                                            pivrow = row;<a name="line.411"></a>
<FONT color="green">412</FONT>                                                            pivcol = col;<a name="line.412"></a>
<FONT color="green">413</FONT>                                                    }<a name="line.413"></a>
<FONT color="green">414</FONT>                                                    break;<a name="line.414"></a>
<FONT color="green">415</FONT>                                            }<a name="line.415"></a>
<FONT color="green">416</FONT>                                    }<a name="line.416"></a>
<FONT color="green">417</FONT>                                    if (pivrow == 0) break;<a name="line.417"></a>
<FONT color="green">418</FONT>                            }<a name="line.418"></a>
<FONT color="green">419</FONT>                            <a name="line.419"></a>
<FONT color="green">420</FONT>                            if (pivcol != piv) {<a name="line.420"></a>
<FONT color="green">421</FONT>                                    stoich.swapColumns(pivcol, piv);<a name="line.421"></a>
<FONT color="green">422</FONT>                                    post.swapColumns(pivcol, piv);<a name="line.422"></a>
<FONT color="green">423</FONT>                                    ch.javasoft.util.Arrays.swap(reversibilities, pivcol, piv);<a name="line.423"></a>
<FONT color="green">424</FONT>                            }<a name="line.424"></a>
<FONT color="green">425</FONT>                    }<a name="line.425"></a>
<FONT color="green">426</FONT>            }<a name="line.426"></a>
<FONT color="green">427</FONT>            <a name="line.427"></a>
<FONT color="green">428</FONT>            //no instances<a name="line.428"></a>
<FONT color="green">429</FONT>            private CompressionUtil() {<a name="line.429"></a>
<FONT color="green">430</FONT>                    super();<a name="line.430"></a>
<FONT color="green">431</FONT>            }<a name="line.431"></a>
<FONT color="green">432</FONT>    }<a name="line.432"></a>




























































</PRE>
</BODY>
</HTML>
